﻿using System;
using System.Reflection;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight.Data;
using C1.C1Zip;
using C1.Silverlight.Olap;
using C1.Silverlight.FlexGrid;

namespace OlapQuickStart
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            // load data from embedded zip resource
            var ds = new DataSet();
            var asm = Assembly.GetExecutingAssembly();
            using (var s = asm.GetManifestResourceStream("OlapQuickStart.nwind.zip"))
            {
                var zip = new C1ZipFile(s);
                using (var zr = zip.Entries[0].OpenReader())
                {
                    // load data
                    ds.ReadXml(zr);
                }
            }

            _c1OlapPage.Loaded += (s, ea) =>
            {
                // bind olap page to data
                _c1OlapPage.DataSource = ds.Tables[0].DefaultView;

                // show sales by country and category
                var olap = _c1OlapPage.OlapPanel.OlapEngine;
                olap.DataSource = ds.Tables[0].DefaultView;
                olap.BeginUpdate();
                olap.RowFields.Add("Country");
                olap.ColumnFields.Add("Category");
                olap.ValueFields.Add("Sales");
                olap.Fields["Sales"].Format = "n0";
                olap.EndUpdate();
                // get OlapEngine to work with
                C1OlapGrid _olapGrid = _c1OlapPage.OlapGrid;
                // add event to display new details
                _olapGrid.AddHandler(MouseRightButtonDownEvent, new MouseButtonEventHandler((_s, _e) =>
                {
                    // get OlapGrid information for the mouse position
                    C1.Silverlight.FlexGrid.HitTestInfo hti = _olapGrid.HitTest(_e.GetPosition(_s as C1OlapGrid));
                    // make sure we are working with a cell
                    if (hti.CellType == C1.Silverlight.FlexGrid.CellType.Cell)
                    {
                        DataRowView row = _olapGrid.SelectedItem as DataRowView;
                        var data = _c1OlapPage.OlapEngine.GetDetail(row.GetRow(), _c1OlapPage.OlapEngine.OlapTable.Columns[hti.Column].ColumnName);

                        // create new details window and pass it data
                        DetailsWindow details = new DetailsWindow(data);
                        // shows new window
                        details.Show();
                    }
                }), true);
            };

         
        }
 
            


    
        void Button_Click(object sender, RoutedEventArgs e)
        {
            // regenerate the olap view
            _c1OlapPage.OlapPanel.OlapEngine.Update();
        }
    }
}
